import java.awt.Dialog;
import java.awt.event.*;
import java.awt.*;
import javax.swing.JOptionPane;

/*
 * Created on 02.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/**
 * @author knoeohcd
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SelectViewedAreaDialog extends Dialog implements ActionListener {
	/**
	 * @param owner
	 */
	public SelectViewedAreaDialog(Frame owner,double ul_real, double ul_imag, double lr_real, double lr_imag) {
		super(owner,"Select fractal subset",true);
		setLayout(new GridLayout(4,3,5,5));
		add(new Panel());
		add(new Label("Real"));
		add(new Label("Imag"));
		add(new Label("Upper left:"));
		add(this.ul_real = new TextField(String.valueOf(ul_real)));
		add(this.ul_imag = new TextField(String.valueOf(ul_imag)));
		add(new Label("Lower right:"));
		add(this.lr_real = new TextField(String.valueOf(lr_real)));
		add(this.lr_imag = new TextField(String.valueOf(lr_imag)));
		add(new Panel());
		pack();
		add(cancelbutton = new Button("Cancel"));
		add(okbutton = new Button("Ok"));
		okbutton.addActionListener(this);
		cancelbutton.addActionListener(this);
	}
	
	/**
	 * Executes the dialog
	 * @return true if the dialog has been closed with the ok button
	 */
	final public boolean showDialog() { this.setVisible(true); return accepted; }

	/**
	 * Getter for the real part of the upper left corner
	 * @return real part of the upper left corner
	 */
	final public double getUpperLeftReal() { return ulreal; }
	
	/**
	 * Getter for the imaginary part of the upper left corner
	 * @return imaginary part of the upper left corner
	 */
	final public double getUpperLeftImag() { return ulimag; }	
		
	/**
	 * Getter for the real part of the lower right corner
	 * @return real part of the lower right corner
	 */
	final public double getLowerRightReal() { return lrreal; }
	
	/**
	 * Getter for the imaginary part of the lower right corner
	 * @return imaginary part of the lower right corner
	 */
	final public double getLowerRightImag() { return lrimag; }
	
	
	
	public void actionPerformed(ActionEvent e)
	{
		if(accepted = (e.getSource() == okbutton))
		{
			try{
				lrreal = Double.parseDouble(lr_real.getText());
				lrimag = Double.parseDouble(lr_imag.getText());
				ulreal = Double.parseDouble(ul_real.getText());
				ulimag = Double.parseDouble(ul_imag.getText());
			}
			catch(NumberFormatException ne)
			{
				JOptionPane.showMessageDialog(this,"Wrong input!","JFractalView",JOptionPane.ERROR_MESSAGE);
				Object source = e.getSource();
				if(source instanceof TextField)
				{
					TextField entry = (TextField) source;
					entry.setText("");
					entry.requestFocus();
				}
				return;
			}
		}
		setVisible(false);
	}
	
	/** text field for the real part of the upper left corner */
	private TextField ul_real;
	/** text field for the imaginary part of the upper left corner */
	private TextField ul_imag;
	/** text field for the real part of the lower right corner */
	private TextField lr_real;
	/** text field for the imaginary part of the lower right corner */
	private TextField lr_imag;
	/** ok button */
	private Button okbutton;
	/** cancel button */
	private Button cancelbutton;
	/** accepted flag */
	boolean accepted=false;
	double ulreal,ulimag,lrreal,lrimag;
}
